datablock AudioProfile(AzureusgunShotSound)
{
   filename    = "./gunshot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(AzureusHitSound)
{
   filename    = "Add-Ons/Projectile_Radio_Wave/radioWaveExplosion.wav";
   description = AudioClose3d;
   preload = true;
};


datablock ParticleData(AzureusGunFlashParticle)
{
   gravityCoefficient=0;
   constantAcceleration=0;
   dragCoefficient=0;
   inheritedVelFactor=1;
   lifetimeMS=30;
   textureName="base/data/particles/cloud";
   spinSpeed=50;
   spinRandomMin=-500;
   spinRandomMax=500;
   colors[0]="0.1 0.1 1 1";
   colors[1]="0.6 0.6 1 1";
   colors[2]="0.3 0.3 1 0";
   sizes[0]=0.1;
   sizes[1]=0.5;
   sizes[2]=0;
   times[9]=0;
   times[1]=0.3;
   times[2]=1;
   useInvAlpha=false;
};
datablock ParticleEmitterData(AzureusGunFlashEmitter)
{
   ejectionPeriodMS=1;
   ejectionVelocity=20;
   velocityVariance=0;
   thetaMin=0;
   thetaMax=70;
   ejectionOffset=0;
   phiReferenceVel=0;
   phiVariance=360;
   overrideAdvance=false;
   particles="AzureusGunFlashParticle";
   uiName="Azureus Gun Flash";
};

datablock ParticleData(AzureusgunTracerParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -4.0;
	spinRandomMax		= 4.0;
	colors[0]="0.3 0.6 0.6 1";
   colors[1]="0.2 0.5 1 0.5";
   sizes[0]=0.1;
   sizes[1]=0.1;
   times[0]=0;
   times[1]=1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(AzureusgunTracerEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = true;
   particles = "AzureusgunTracerParticle";

   useEmitterColors = false;
   uiName = "Azureus Gun Tracer";
};

datablock ParticleData(AzureusgunExplosionParticle)
{
	dragCoefficient      = 10;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.4 0.9 0.9 0.9";
	colors[1]     = "0.3 0.5 0.9 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(AzureusgunExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0.5;
   velocityVariance = 0.5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "AzureusgunExplosionParticle";

   useEmitterColors = true;
   uiName = "Azureus Gun Hit Dust";
};


datablock ParticleData(AzureusgunExplosionRingParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0 0.6 0.6 0.9";
	colors[1]     = "0 0.0 0.5 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(AzureusgunExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 5;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "AzureusgunExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Azureus Gun Hit Flash";
};

datablock ExplosionData(AzureusgunExplosion)
{
   //explosionShape = "";
	soundProfile = AzureusHitSound;

   lifeTimeMS = 150;

   particleEmitter = AzureusgunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = AzureusgunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 2;
   lightStartColor = "0.0 0.9 0.9";
   lightEndColor = "0 0.1 0.5";
};


AddDamageType("AzureusGun",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(AzureusgunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::AzureusGun;
   radiusDamageType    = $DamageType::AzureusGun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;
   brickExplosionMaxVolumeFloating = 2;

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = AzureusgunExplosion;
   Bounceexplosion           = AzureusgunExplosion;
   particleEmitter     = "AzureusGunTracerEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 2000;
   fadeDelay           = 3500;
   
   bounceElasticity    = 0.99;
   bounceAngle = 0;
   bounceFriction      = 0;
   minStickVelocity = "0";
   explodeOnPlayerImpact = "1";
   explodeOnDeath = "1";
   collideWithPlayers = "1";
   isBallistic         = 1;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0.6 0.9";

   uiName = "Azureus Gun Bullet";
};

datablock ItemData(AzureusGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./azureusPistol.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Azureus Gun";
	iconName = "./icon_azureus";
	doColorShift = false;
	image = AzureusgunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(AzureusgunImage)
{
   shapeFile = AzureusGunItem.shapeFile;
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = true;
   className = "WeaponImage";
   
   projectile = AzureusgunProjectile;
   projectileType = Projectile;
   
   melee = false;
   armReady = true;

   doColorShift = false;

   
	stateSequence[0]                = "Start";
	stateSequence[1]                = "Ready";
	stateSequence[2]                = "Fire";
	stateSequence[3]                = "Ready";
   
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= AzureusGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= AzureusgunShotSound;
	stateEjectShell[2]       = true;

	stateName[3]			= "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";

};

function AzureusgunImage::onFire(%this,%obj,%slot)
{
	Parent::onFire(%this,%obj,%slot);
	//mSetTimescale(0.2);
	//cancel($mSet);
	//$mSet=schedule(200,0,mSetTimescale,1);
}


datablock ItemData(AkimboAzureusGunItem : AzureusGunItem)
{
	uiName = "Azureus Guns Akimbo";
	shapeFile = AzureusGunItem.shapeFile;
	iconName = "./icon_azureusAkimbo";
	colorShiftColor = "0.5 1 1 1";
	image = AkimboAzureusGunImage;
};

datablock ShapeBaseImageData(AkimboAzureusGunImage)
{
   shapeFile = AzureusGunItem.shapeFile;
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   correctMuzzleVector = true;

   className = "WeaponImage";
   projectile = AzureusGunProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = AzureusGunItem.colorShiftColor;
   
   stateSequence[0]                = "Start";
	stateSequence[1]                = "Ready";
	stateSequence[2]                = "Fire";
	stateSequence[3]                = "Ready";
	
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 1;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateTransitionOnTimeout[2] = "Reload";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.05;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = AzureusgunShotSound;
   stateEmitter[2]					= AzureusgunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "FireAkimbo";

	stateName[4] = "FireAkimbo";
	stateTimeoutValue[4] = 0.05;
	stateScript[4] = "onFireAkimbo";
	stateTransitionOnTimeOut[4] = "ready";
};


function AkimboAzureusGunImage::onFireAkimbo(%this,%obj,%slot)
{
   %obj.setImageTrigger(1,1);
}


datablock ShapeBaseImageData(LeftHandedAzureusGunImage)
{
   shapeFile = AzureusGunItem.shapeFile;
   emap = true;

   mountPoint = 1;
   offset = "0 0 0";
   correctMuzzleVector = true;
   className = "WeaponImage";
   projectile = AzureusGunProjectile;
   projectileType = Projectile;

   melee = false;
   
   armReady = false;

   doColorShift = false;
   colorShiftColor = AkimboAzureusGunImage.colorShiftColor;
   
   stateSequence[0]                = "Start";
	stateSequence[1]                = "Ready";
	stateSequence[2]                = "Fire";
	stateSequence[3]                = "Ready";
   
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 1;
   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateTransitionOnTimeout[2] = "Reload";
   stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.05;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
	stateSound[2] = AzureusgunShotSound;
   stateEmitter[2]					= AzureusgunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";


};

function LeftHandedAzureusGunImage::onFire(%this, %obj, %slot)
{
   Parent::onFire(%this,%obj,%slot);
   //if(%obj.getDamagePercent() < 1.0)
		//%obj.playThread(2, leftrecoil);
}

function AkimboAzureusGunImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(LeftHandedAzureusGunImage, 1);
}
function AkimboAzureusGunImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   %obj.unMountImage(1);
}

function LeftHandedAzureusGunImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function LeftHandedAzureusGunImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}

function AkimboAzureusGunImage::onFire(%this,%obj,%slot)
{
	//if(%obj.getDamagePercent() < 1.0)
		//%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}
